import java.awt.*;
import java.awt.image.*;
import java.io.*;
import javax.imageio.*;
import javax.swing.*;
import javax.swing.text.*;

/**
 * Eigenes Grafik-Panel
 * 
 * @author Toens
 * @version v0.1
 */
public class JGrafikPanel extends JPanel {
    Ameise[] ameisenstaat;
    boolean entered = false;
    Point mousePosition = new Point();
    
    public void setAmeisenstaat(Ameise[] as) {
        ameisenstaat = as;
    }
    
    public void setMousePosition(Point p) {
        mousePosition = p;
    }
    
    public void setEntered(boolean e) {
        entered = e;
    }
    
    public void nextFrame() {
        // Sicherstellen, dass das Array existiert
        if(ameisenstaat !=  null) {
            // Jede "Ameise" aus dem Array bewegen!
            Ameise.mousePosition = mousePosition;
            for(int i=0; i<ameisenstaat.length; i++) {
                ameisenstaat[i].bewegung();
            }
        }
    }

    /**
     * Kernstueck des JGrafikPanels: paintComponent ist eine Methode, die
     * eigentlich von der Oberklasse JPanel stammt (unser JGrafikPanel erbt
     * ja von der JPanel-Klasse). Hier wird die Methode ueberschrieben.
     * Wir sorgen hier naemlich dafuer, dass unsere eigenen Inhalte dort
     * hineingezeichnet werden. Die Methode wird immer dann vom Fenstersystem
     * (bzw. indirekt vom Windows-Betriebssystem) aufgerufen, wenn der Inhalt
     * neu gezeichnet werden soll.
     */
    public void paintComponent(Graphics g) {
        Graphics2D g2 = (Graphics2D)g;
        g2.setRenderingHint(RenderingHints.KEY_ANTIALIASING,
            RenderingHints.VALUE_ANTIALIAS_ON);
        g2.setRenderingHint(RenderingHints.KEY_INTERPOLATION,
            RenderingHints.VALUE_INTERPOLATION_BILINEAR);

        super.paintComponent(g); // Zur Sicherheit die urspruengliche Methoder der Oberklasse aufrufen

        Rectangle r = getBounds(null);
        int h = r.height; // Höhe
        int w = r.width;  // Breite

        g.setColor(Color.lightGray);
        g.fillRect(0,0,w,h);       // Hintergrund füllen
       
        // Sicherstellen, dass das Array existiert
        if(ameisenstaat !=  null) {
            // Jede "Ameise" aus dem Array zeichnen!
            for(int i=0; i<ameisenstaat.length; i++) {
                ameisenstaat[i].paint(g);
            }
        }
        
    }
}
